<template>
  <div id="sidebar">
    <b-sidebar
      type="is-light"
      :open.sync="open"
      :can-cancel="false"
    >
      <div
        class="columns is-vcentered is-flex"
        style="flex-direction: column; height: 100vh"
      >
        <div
          class="column"
          style="width: 100%; padding-top: 24px"
        >
          <b-menu>
            <b-menu-list>
              <!-- Transaction -->
              <b-menu-item>
                <template
                  slot="label"
                  slot-scope="props"
                >
                  <div
                    class="flex-container is-flex"
                    style="align-items: center"
                  >
                    <b-icon
                      :icon="props.expanded ? 'angle-down' : 'angle-right'"
                      size="is-medium"
                    />
                    <div class="router-name">
                      Transaction
                    </div>
                  </div>
                </template>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/transaction"
                  :active="this.$route.path === '/transaction'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Transaction List
                      </div>
                    </div>
                  </template>
                </b-menu-item>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/transaction/complaint-list"
                  :active="this.$route.path === '/transaction/complaint-list'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Complaint List
                      </div>
                    </div>
                  </template>
                </b-menu-item>
              </b-menu-item>

              <!-- Product Management -->
              <b-menu-item>
                <template
                  slot="label"
                  slot-scope="props"
                >
                  <div
                    class="flex-container is-flex"
                    style="align-items: center"
                  >
                    <b-icon
                      :icon="props.expanded ? 'angle-down' : 'angle-right'"
                      size="is-medium"
                    />
                    <div class="router-name">
                      Product Management
                    </div>
                  </div>
                </template>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/product"
                  :active="this.$route.path === '/product'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Product
                      </div>
                    </div>
                  </template>
                </b-menu-item>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/product/brand"
                  :active="this.$route.path === '/product/brand'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Brand
                      </div>
                    </div>
                  </template>
                </b-menu-item>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/product/category"
                  :active="this.$route.path === '/product/category'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Category
                      </div>
                    </div>
                  </template>
                </b-menu-item>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/product/variant"
                  :active="this.$route.path === '/product/variant'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Variant
                      </div>
                    </div>
                  </template>
                </b-menu-item>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/product/supplier"
                  :active="this.$route.path === '/product/supplier'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Supplier
                      </div>
                    </div>
                  </template>
                </b-menu-item>
              </b-menu-item>

              <!-- Stock Management -->
              <b-menu-item>
                <template
                  slot="label"
                  slot-scope="props"
                >
                  <div
                    class="flex-container is-flex"
                    style="align-items: center"
                  >
                    <b-icon
                      :icon="props.expanded ? 'angle-down' : 'angle-right'"
                      size="is-medium"
                    />
                    <div class="router-name">
                      Stock Management
                    </div>
                  </div>
                </template>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/stock"
                  :active="this.$route.path === '/stock'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        In/Out Stock
                      </div>
                    </div>
                  </template>
                </b-menu-item>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/stock/stock-opname"
                  :active="this.$route.path === '/stock/stock-opname'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Stock Opname
                      </div>
                    </div>
                  </template>
                </b-menu-item>

                <b-menu-item
                  v-if="checkRoles('PO.index') && currentUser.branchId == 1"
                  tag="router-link"
                  target="_self"
                  to="/stock/purchase-order"
                  :active="this.$route.path === '/stock/purchase-order'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Purchase Order
                      </div>
                    </div>
                  </template>
                </b-menu-item>

                <b-menu-item
                  v-if="checkRoles('RO.index') && (currentUser.branchId != 1 || currentUser.role.name == 'supervisor')"
                  tag="router-link"
                  target="_self"
                  to="/stock/request-order"
                  :active="this.$route.path === '/stock/request-order'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Request Order
                      </div>
                    </div>
                  </template>
                </b-menu-item>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/stock/mutation"
                  :active="this.$route.path === '/stock/mutation'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Mutation
                      </div>
                    </div>
                  </template>
                </b-menu-item>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/stock/stock-list"
                  :active="this.$route.path === '/stock/stock-list'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Stock List
                      </div>
                    </div>
                  </template>
                </b-menu-item>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/stock/stock-card"
                  :active="this.$route.path === '/stock/stock-card'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Stock Card
                      </div>
                    </div>
                  </template>
                </b-menu-item>
              </b-menu-item>

              <!-- Benefit Management -->
              <b-menu-item>
                <template
                  slot="label"
                  slot-scope="props"
                >
                  <div
                    class="flex-container is-flex"
                    style="align-items: center"
                  >
                    <b-icon
                      :icon="props.expanded ? 'angle-down' : 'angle-right'"
                      size="is-medium"
                    />
                    <div class="router-name">
                      Promotion Management
                    </div>
                  </div>
                </template>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/promotion"
                  :active="this.$route.path === '/promotion'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Promotion List
                      </div>
                    </div>
                  </template>
                </b-menu-item>
              </b-menu-item>

              <!-- User Management -->
              <b-menu-item>
                <template
                  slot="label"
                  slot-scope="props"
                >
                  <div
                    class="flex-container is-flex"
                    style="align-items: center"
                  >
                    <b-icon
                      :icon="props.expanded ? 'angle-down' : 'angle-right'"
                      size="is-medium"
                    />
                    <div class="router-name">
                      User Management
                    </div>
                  </div>
                </template>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/user"
                  :active="this.$route.path === '/user'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Staff List
                      </div>
                    </div>
                  </template>
                </b-menu-item>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/user/role"
                  :active="this.$route.path === '/user/role'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Role
                      </div>
                    </div>
                  </template>
                </b-menu-item>
              </b-menu-item>

              <!-- News -->
              <b-menu-item>
                <template
                  slot="label"
                  slot-scope="props"
                >
                  <div
                    class="flex-container is-flex"
                    style="align-items: center"
                  >
                    <b-icon
                      :icon="props.expanded ? 'angle-down' : 'angle-right'"
                      size="is-medium"
                    />
                    <div class="router-name">
                      News
                    </div>
                  </div>
                </template>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/news"
                  :active="this.$route.path === '/news'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        News List
                      </div>
                    </div>
                  </template>
                </b-menu-item>
              </b-menu-item>

              <!-- Reports -->
              <b-menu-item>
                <template
                  slot="label"
                  slot-scope="props"
                >
                  <div
                    class="flex-container is-flex"
                    style="align-items: center"
                  >
                    <b-icon
                      :icon="props.expanded ? 'angle-down' : 'angle-right'"
                      size="is-medium"
                    />
                    <div class="router-name">
                      Reports
                    </div>
                  </div>
                </template>

                <b-menu-item
                  tag="router-link"
                  target="_self"
                  to="/reports"
                  :active="this.$route.path === '/reports'"
                >
                  <template slot="label">
                    <div
                      class="flex-container is-flex"
                      style="align-items: center"
                    >
                      <b-icon
                        class="mr-2"
                        icon="circle"
                        size="is-small"
                      />
                      <div class="sub-router-name">
                        Reports
                      </div>
                    </div>
                  </template>
                </b-menu-item>
              </b-menu-item>
            </b-menu-list>
          </b-menu>
        </div>
      </div>
    </b-sidebar>
  </div>
</template>

<script>
export default {
  props: {
    isSidebarOpen: Boolean,
    currentUser: Object
  },
  data () {
    return {
      open: false,
      // Sidebar menu
      isTransaction: false,
      rolesArray: []
    };
  },
  watch: {
    isSidebarOpen: function (val) {
      this.open = val;
    }
  },
  mounted() {
    this.rolesArray = this.currentUser.role.activePermissions;
  },
  methods: {
    // Check Roles
    checkRoles (role) {
      const check = this.rolesArray.filter(element => {
        return element.name == role;
      });

      if (check.length == 0) {
        return false;
      } else {
        return true;
      }
    }
  }
};
</script>

<style scoped>
.router-name {
  font-weight: 700;
  font-size: 20px;
  padding-bottom: 3px;
}
</style>
